
;---------------------------------------
; NORMAL FLOPPY SPEEDER EPROM VERZE ...
;---------------------------------------
d_speed   = *

         lda $b9     ;*** ",x,1 ?
         sta pom5    ;***

         lda #$01
         tay
         sta $b8     ;SETLFS
         sty $b9

         ldy $ba     ;c.kanalu = c.zar.
         sty $b8     ;c. akt. kanalu

         lda #$60
         sta $b9     ;sekundarni adresa
         jsr $f3d5                      ;Vyslani nazvu souboru po ser. sber.
         jsr i9f2d
         bcc drisrd
         rts         ;EXIT ERR.
;---------------------------------------
; Inicializace prenosu & prenos do drivu
;---------------------------------------
drisrd   jsr send_reader
;---------------------------------------
; Prenos dat ...
;---------------------------------------
         sei        ;SEI ****
         lda #0
         sta pom2

         sta cfg_open
         lda machine_type_exp
         sta cfg_16
         bne mlntsc

         jsr loadbytepal ;vynda 1  (start-
         bvs loadsto
         sta $ae
         jsr loadbytepal ;vynda 1  -adresu)
         bvs loadsto
         bvc mlpal

mlntsc   jsr loadbytentsc ;vynda 1  (start-
         bvs loadsto
         sta $ae
         jsr loadbytentsc ;vynda 1  -adresu)
         bvs loadsto

mlpal    sta $af

         lda pom5   ;podle vstup.
         bne oddec  ;param.

         lda $c3
         sta $ae
         lda $c4
         sta $af
oddec    lda $af
         sta pom2
         cmp #$08          ;Pokud je < $0800 tak neprintuje 'from ...'
         bcc d_sp_no
         lda $ae
         sta pom1
         jsr prn_from0     ;Tisk from $xxxx
         sei               ;Tisk nahazuje IRQ !!!
d_sp_no  ldy $ae
         lda #$00
         sta $ae
         ldx #$33
         lda $01
         pha
         sta cfg_open
         lda machine_type_exp
         sta cfg_16
         bne loadlonp

loadloop jsr loadbytepal
         bvs loadstop
         stx $01           ;Soci: It's not a bad idea to load under $Dxxx
         sta ($ae),y
         lda #$37
         sta $01
         iny
         bne loadloop
         inc $af
         bne loadloop
         beq loadstop

loadlonp jsr loadbytentsc
         bvs loadstop
         stx $01           ;Soci: It's not a bad idea to load under $Dxxx
         sta ($ae),y
         lda #$37
         sta $01
         iny
         bne loadlonp
         inc $af
         bne loadlonp

loadstop sty $ae
         pla
         sta $01
loadsto  jsr i9f2d
         bcs par_ok
         jsr $edfe  ;UNLSN
         sec
         rts        ;KONEC ERR.
par_ok   lda pom2
         cmp #$08          ;Pokud je < $0800 tak neprintuje '... to ...'
         bcc d_sp_end
         lda $ae
         sta pom1
         lda $af
         sta pom2
         jsr prn_from1         ;tisk  - to
d_sp_end lda #$40              ;status o.k
         sta $90
         clc                   ;KONEC O.K.
         ldx $ae
         ldy $af
         rts
;----------------- Prijme byte z BUSu
loadbytepal sec
i9edc    bit $dd00
         bvc i9f17
         bmi i9edc
i9ee3    lda $d012
         sbc #$32
         bcc i9eee
         and #$07
         beq i9ee3
i9eee    lda #$10
         eor $dd00
         sta $dd00
         bit $00     ;3 cykly
         clv         ;2 cykly
         and #$03    ;2 cykly
         sta pom1    ;3 cykly
         sta $dd00
         lda $dd00
         lsr a
         lsr a
         eor $dd00
         lsr a
         lsr a
         eor $dd00
         lsr a
         lsr a
         eor $dd00
         eor pom1
         rts
i9f17    bit Overflow_to_1 ;End of file
         rts

loadbytentsc sec
i9edcn   bit $dd00
         bvc i9f17
         bmi i9edcn
i9ee3n   lda $d012
         sbc #$32
         bcc i9eeen
         and #$07
         beq i9ee3n
i9eeen   lda #$10
         eor $dd00
         sta $dd00
         nop
         nop
         clv         ;2 cykly
         and #$03    ;2 cykly
         sta pom1    ;3 cykly
         sta $dd00
         lda $dd00
         lsr a
         lsr a
         eor $dd00
         lsr a
         lsr a
         eor $dd00
         lsr a
         lsr a
         eor $dd00
         eor pom1
         rts

send_reader = *
         lda #<do_dr   ;soft do drivu
         ldx #>do_dr   ;start adr.
         sta pom1      ;@
         stx pom2      ;@
         lda #$00
         ldx #$04
         sta pom3      ;@
         stx pom4      ;@

i9e71    jsr i9f18

         ldx #2
i9e76    lda f9f27,x
         jsr $eddd
         dex
         bpl i9e76
         lda pom3
         jsr $eddd
         lda pom4
         jsr $eddd
         lda #$20      ;nc
         jsr $eddd

         ldy #0

i9e7f    lda (pom1),y  ;#OK
         jsr $eddd
         iny
         cpy #$20
         bne i9e7f
         jsr $edfe     ;UNLSN

         lda pom1
         clc
         adc #$20
         sta pom1
         bcc i9e9b
         inc pom2
i9e9b    lda pom3
         clc
         adc #$20
         sta pom3
         bne i9e71
         jsr i9f18

;---------------------------------------
; Spusteni softu v drivu
;---------------------------------------
         ldy #$04
i9eab    lda spst,y
         jsr $eddd
         dey
         bpl i9eab
         jmp $edfe

i9f18    lda $ba     ;kod periferie
         jsr $ed0c   ;LISTEN
         lda #$6f
         jsr $edb9   ;SECOND
         ldy #0
fgdv     dey
         bne fgdv
         rts
;---------------------------------------
f9f27    .byte $57,$2d,$4d    ;"w-m
spst                     ;je tu do poctu
         .byte $04,$6a       ;start adr.
         .byte $45,$2d,$4d   ;"e-m
;---------------------------------------
i9f2d    lda $ba     ;kod periferie
         jsr $ed09   ;TALK
         lda $b9     ;sekundarni adresa
         jsr $edc7   ;TKSA
         jsr $ee13   ;ACPTR
         lda $90     ;stavovy byte
         lsr
         lsr         ;Soci: set C
         rts
;---------------------- DO DRIVU -------
do_dr    lda #$03
         sta $31
i9f46    jsr $0150
         lda #$00
         ldx $0301
         stx $09
         stx $81
         ldy $0300
         bne i9f59
         inx
         txa
i9f59    sta $85
         ldy #$02
i9f5d    lda ($30),y
         sty $14
         tay
         and #$0f
         tax
         tya
         lsr a
         lsr a
         lsr a
         lsr a
         tay
         lda #$02
         sta $1800
         asl a
i9f71    bit $1800
         beq i9f71
         lda $04ad,x
         sta $1800
         asl a
         and #$0f
         sta $1800
         lda $04ad,y
         sta $1800
         asl a
         and #$0f
         sta $1800
         ldy $14
         lda #$00
         sta $1800
         iny
         cpy $85
         bne i9f5d
         lda $0300
         cmp $08
         beq i9f46
         sta $80
         jmp $f418
         lda #$08
         sta $1800
         rts
         lda #$10
         sta $1c07
         ldx #$39
i9fb3    lda $f4d0,x
         sta $014f,x
         dex
         bne i9fb3
         stx $1800
         lda #$60
         sta $0184
         lda $19
         sta $09
         lda $18
i9fca    cmp #$24
         bcs i9fe8
         sta $08
         lda #$e0
         sta $01
i9fd4    lda $01
         bmi i9fd4
         cmp #$01
         beq i9fe4
         jsr $0464
         ldx #$01
         jmp $d599
i9fe4    lda $80
         bne i9fca
i9fe8    sei
         jsr $0464
         jmp $eb22
         .byte $0f,$07,$0d,$05
         .byte $0b,$03,$09,$01
         .byte $0e,$06,$0c,$04
         .byte $0a,$02,$08,$00

		.comment
dostuff		sei			;fb64
		jsr $d6d0		;transmit param
                tya
                lsr
                tax
                lda #$80
                jsr $d50e               ;check track/sector
                .byte $2c
                lda #$90
                pha
                txa
                asl
                tay
                lda $06,y
                cmp $22
                beq kf
                lda #$b0
                jsr ind
kf              pla
		pha
                sta $00,x
                stx $3f
                lda $1c0c
                ora #$0e
                sta $1c0c
                jsr $f393		;init pointer
                txa
                pha
                lda $00,x
                jsr ez			;$fbad		;??
                pla
                tax
                lda $00,x
                cmp #2
                pla
                bcc ke
ind             jsr $d50e
                cli
                jsr $d599		;verify exec
                sei
ke		rts

ez		tsx
                stx $49
                and #$30
                bne *+5
                jmp $f4d1		;read sector
                and #$20
                bne *+5
                jmp $f575		;write sector
                jmp $f698		;compare sector



                lda $31			;ff2d
                pha

;;                jsr $e96d		;??
ds		jsr $ea59		;test atn
                ror
                bcs ds
                
                lda #4
llf             pha
                ldy #1
                lda ($30),y
                sta $81
                tax
                dey
                lda ($30),y
                sta $80
                bne kv2
                pla
                clc
                sbc $81
                inx
                stx $30
                beq kv
                dec $31
kv		pha
kv2		pla
		tay
                jsr send
                lda $80
                beq af
                jsr dostuff		;$fb64		;??
                lda #2
                gne llf

af		sta $30
		pla
                sta $31
                jsr iv
                jsr iv
                jsr $e9ae		;clk out hi
		ldx #20
                dex
                bne *-1
                jmp $e9b7		;clk out lo	ff73
vx              jmp $e85b		;service serial bus

send            lda $1800		;ff8d
                and #$60
                sta $7a
                ora #$0d
                sta $44
                jsr $e9a5		;data out hi
                eor #$0d
                sta $1800

                jsr $fef3		;delay for 1541
lp		lda ($30),y		;ffa3
		tax
		lsr
		lsr
		lsr
		lsr
		sta $4b
		txa
                and #$0f
                tax
		lda tabla,x
                ldx $7a
                stx $1800
                cpx $1800
                beq *-3
                sta $1800
                asl
                and #$0f
                nop
                sta $1800
                ldx $4b
                lda tabla,x
                sta $1800
                asl
                and #$0f
                iny
                sta $1800
                bne lp
                nop
                lda $44
                sta $1800
vsm             cmp $1800
                bcc vx
                bne vsm
                rts

tabla          .byte $0f,$07,$0d,$05
               .byte $0b,$03,$09,$01
               .byte $0e,$06,$0c,$04
               .byte $0a,$02,$08,$00

                .endc

