;
; crosslnk.asm - Cross bank jumper
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; Generated automatically. DO NOT EDIT!
;
			.if BANK=0
append_status_dec       sta bank_port1                  ;0000 -> 0006
			jsr OP_findunusedchannel        ;0003 <- BANK1
exitbank1               sta bank_port1                  ;0006
			rts				;0009
call_setup              sta bank_port1                  ;000A -> 0010
			jsr OP_XIT_check_partition_selection;000D <- BANK1
                        sta bank_port1                  ;0010
			rts				;0013
LWOP_disk_status        sta bank_port1                  ;0014 -> 001A
			jsr set_power_management_and_features;0017 <- BANK1
                        sta bank_port1                  ;001A
			rts				;001D
LWOP_get_cmos_setup     sta bank_port1                  ;001E -> 0024
			jsr OP_hdinit                   ;0021 <- BANK2
exitbank2               sta bank_port2                  ;0024
			rts				;0027
check_drive             sta bank_port2                  ;0028 -> 002E
			jsr OP_init_buffer_pointers     ;002B <- BANK2
                        sta bank_port2                  ;002E
			rts				;0031
find_free_sector        sta bank_port2                  ;0032 -> 0038
			jsr OP_XIT_check_partition_selection;0035 <- BANK2
                        sta bank_port2                  ;0038
			rts				;003B
OP_XIT_do_command_channel sta bank_port2                  ;003C -> 0042
			jsr OP_XIT_hdinit_2             ;003F <- BANK2
                        sta bank_port2                  ;0042
			rts				;0045
OP_XIT_execute_15command_open sta bank_port2                  ;0046 -> 004C
			jsr OP_XIT_init_filesystem_from_disk;0049 <- BANK2
                        sta bank_port2                  ;004C
			rts				;004F
update_filelen          sta bank_port2                  ;0050 -> 0056
			jsr search_buffer_A             ;0053 <- BANK2
                        sta bank_port2                  ;0056
			rts				;0059
XIT_finalize_direntry   sta bank_port2                  ;005A -> 0060
			jsr XIT_flush_buf               ;005D <- BANK2
                        sta bank_port2                  ;0060
			rts				;0063
XIT_find_free_flush     sta bank_port2                  ;0064 -> 006A
			jsr LWNO_set_new314vect         ;0067 <- BANK3
exitbank3               sta bank_port3                  ;006A
			rts				;006D
pclink_open_real        sta bank_port3                  ;006E -> 0074
			jsr LWOP_init_c128key           ;0071 <- BANK3
                        sta bank_port3                  ;0074
			rts				;0077
XIT_dir_first           sta bank_port3                  ;0078 -> 007E
			jsr OP_findunusedchannel        ;007B <- BANK3
                        sta bank_port3                  ;007E
			rts				;0081
XIT_dirlp2              sta bank_port3                  ;0082 -> 0088
			jmp hackedb2                    ;0085 <- BANK3
monitor                 sta bank_port3                  ;0088
			rts				;008B
			.text "64"			;008C
newconsole              sta bank_port3                  ;008E
			jmp listbank0                   ;0091 <- BANK3
LWOP_read_clock         sta bank_port1                  ;0094 -> 009A
			jmp mymisc                      ;0097 <- BANK3
manager                 sta bank_port2                  ;009A
			rts				;009D
			.text "64"			;009E
			jmp overt                       ;00A0 <- BANK3
newload                 sta bank_port1                  ;00A3
newread                 sta bank_port1                  ;00A6
newsave                 sta bank_port1                  ;00A9
newwrite                sta bank_port1                  ;00AC
OP_atapi_command        sta bank_port1                  ;00AF -> 00B5
			.text "C64"			;00B2
OP_atapi_packet         sta bank_port1                  ;00B5 -> 00BB
			rts				;00B8
			.text "64"			;00B9
OP_copy_filename_to_path sta bank_port1                  ;00BB -> 00C1
			rts				;00BE
			.text "64"			;00BF
OP_XIT_resolv_path_part sta bank_port1                  ;00C1 -> 00C7
			rts				;00C4
XIT_init_drive          sta bank_port2                  ;00C5 -> 00CB
			.text "64"			;00C8
			rts				;00CA
XIT_load_tree           sta bank_port2                  ;00CB -> 00D1
			rts				;00CE
			.text "64"			;00CF
XIT_prealloc_dir_sector sta bank_port2                  ;00D1 -> 00D7
			rts				;00D4
			.text "64"			;00D5
XIT_read_a_sector       sta bank_port2                  ;00D7 -> 00DD
			rts				;00DA
			.text "64"			;00DB
XIT_read_in_buffer      sta bank_port2                  ;00DD -> 00E3
			rts				;00E0
			.text "64"			;00E1
XIT_save_tree           sta bank_port2                  ;00E3 -> 00E9
			rts				;00E6
			.text "64"			;00E7
XIT_write_a_sector      sta bank_port2                  ;00E9 -> 00EF
			rts				;00EC
			.text "64"			;00ED
XIT_write_out_buffer    sta bank_port2                  ;00EF -> 00F5
			rts				;00F2
			.text "IDE64"			;00F3
			rts				;00F8
			.text "IDE64"			;00F9
XIT_read_a_sector2      sta bank_port2                  ;00FE -> 0104
			.text "IDE64"			;0101
			.text "!"			;0106
			rts				;0107
			.fi

			.if BANK=1
OP_findunusedchannel    sta bank_port0                  ;0000 -> 0006
			jsr append_status_dec           ;0003 <- BANK0
exitbank0               sta bank_port0                  ;0006
			rts				;0009
OP_XIT_check_partition_selection sta bank_port0                  ;000A -> 0010
			jsr call_setup                  ;000D <- BANK0
                        sta bank_port0                  ;0010
			rts				;0013
set_power_management_and_features sta bank_port0                  ;0014 -> 001A
			jsr LWOP_disk_status            ;0017 <- BANK0
                        sta bank_port0                  ;001A
			rts				;001D
OP_read_to_direntry     sta bank_port3                  ;001E -> 0024
			jsr LWOP_get_cmos_setup         ;0021 <- BANK0
                        sta bank_port0                  ;0024
			rts				;0027
			.text "64"			;0028
			jsr append_status_dec           ;002A <- BANK3
exitbank3               sta bank_port3                  ;002D
XIT_dir_first           sta bank_port3                  ;0030 -> 0036
			.text "IDE64"			;0033
			.text "!"			;0038
			rts				;0039
			.text "64"			;003A
			jsr iecin                       ;003C <- BANK3
                        sta bank_port3                  ;003F
XIT_dirlp2              sta bank_port3                  ;0042 -> 0048
			.text "IDE64"			;0045
			.text "!"			;004A
			rts				;004B
			.text "64"			;004C
			jsr ieclisten                   ;004E <- BANK3
                        sta bank_port3                  ;0051
monitor                 sta bank_port3                  ;0054
			.text "C64"			;0057
pclink_load             sta bank_port3                  ;005A
			jsr iecout                      ;005D <- BANK3
                        sta bank_port3                  ;0060
			jsr iectalk                     ;0063 <- BANK3
                        sta bank_port3                  ;0066
			.text "SOCI"			;0069
check_drive             sta bank_port2                  ;006D -> 0073
			jsr append_status_dec           ;0070 <- BANK2
exitbank2               sta bank_port2                  ;0073
			rts				;0076
find_free_sectors_tree  sta bank_port2                  ;0077 -> 007D
			jsr is_special_s                ;007A <- BANK2
                        sta bank_port2                  ;007D
			rts				;0080
linearaccess            sta bank_port2                  ;0081 -> 0087
			jsr LWOP_disk_status            ;0084 <- BANK2
                        sta bank_port2                  ;0087
			rts				;008A
			.text "C64"			;008B
			jsr OP_get_partnum              ;008E <- BANK2
                        sta bank_port2                  ;0091
pclink_save             sta bank_port3                  ;0094
			jsr LWOP_read_clock             ;0097 <- BANK0
                        sta bank_port0                  ;009A
			jsr iectksa                     ;009D <- BANK3
                        sta bank_port3                  ;00A0
			jmp load_end                    ;00A3 <- BANK3
			jmp newload                     ;00A6 <- BANK0
			jmp newread                     ;00A9 <- BANK0
			jmp newsave                     ;00AC <- BANK0
			jmp newwrite                    ;00AF <- BANK0
			jsr OP_atapi_command            ;00B2 <- BANK0
                        sta bank_port0                  ;00B5
			jsr OP_atapi_packet             ;00B8 <- BANK0
                        sta bank_port0                  ;00BB
			jsr OP_copy_filename_to_path    ;00BE <- BANK0
                        sta bank_port0                  ;00C1
			jsr OP_XIT_resolv_path_part     ;00C4 <- BANK0
                        sta bank_port0                  ;00C7
			jsr iecunlisten                 ;00CA <- BANK3
                        sta bank_port3                  ;00CD
			jsr iecuntalk                   ;00D0 <- BANK3
                        sta bank_port3                  ;00D3
			jsr iecsecond                   ;00D6 <- BANK3
                        sta bank_port3                  ;00D9
			jsr LWOP_disk_status            ;00DC <- BANK3
                        sta bank_port3                  ;00DF
			jsr OP_atapi_packet             ;00E2 <- BANK3
                        sta bank_port3                  ;00E5
			jsr check_wildcards             ;00E8 <- BANK3
                        sta bank_port3                  ;00EB
			jsr check_wildtype              ;00EE <- BANK3
                        sta bank_port3                  ;00F1
			.text "!"			;00F4
XIT_init_drive          sta bank_port2                  ;00F5 -> 00FB
			jsr OP_atapi_datain_command     ;00F8 <- BANK3
                        sta bank_port3                  ;00FB
			rts				;00FE
			.text "64"			;00FF
			jsr OP_short_path               ;0101 <- BANK2
                        sta bank_port2                  ;0104
XIT_load_tree           sta bank_port2                  ;0107 -> 010D
			jsr OP_copy_filename_to_path    ;010A <- BANK3
                        sta bank_port3                  ;010D
			rts				;0110
			.text "64"			;0111
			jsr OP_XIT_partnum_delimiter    ;0113 <- BANK2
                        sta bank_port2                  ;0116
XIT_read_a_sector       sta bank_port2                  ;0119 -> 011F
			jsr OP_path_searchtype          ;011C <- BANK3
                        sta bank_port3                  ;011F
			rts				;0122
			.text "64"			;0123
			jsr OP_XIT_resolv_path          ;0125 <- BANK2
                        sta bank_port2                  ;0128
			jsr OP_short_path               ;012B <- BANK3
                        sta bank_port3                  ;012E
			jsr OP_XIT_resolv_path_part     ;0131 <- BANK3
                        sta bank_port3                  ;0134
			jsr load_install_write_verify_byte;0137 <- BANK3
                        sta bank_port3                  ;013A
			jsr OP_load_loading             ;013D <- BANK3
                        sta bank_port3                  ;0140
			jsr OP_XIT_resolv_path_part     ;0143 <- BANK2
                        sta bank_port2                  ;0146
XIT_save_tree           sta bank_port2                  ;0149 -> 014F
			jsr OP_load_searching_for       ;014C <- BANK3
                        sta bank_port3                  ;014F
			rts				;0152
XIT_upload_next_sector  sta bank_port2                  ;0153 -> 0159
			jsr OP_save_saving              ;0156 <- BANK3
                        sta bank_port3                  ;0159
			rts				;015C
			.fi

			.if BANK=2
getcconv                sta bank_port3                  ;0000 -> 0006
			jsr numtoasc16                  ;0003 <- BANK3
exitbank3               sta bank_port3                  ;0006
			rts				;0009
			.text "C64"			;000A
			jsr XIT_upload_next_sector      ;000D <- BANK3
                        sta bank_port3                  ;0010
			.text "IDE64"			;0013
			.text "IDE64"			;0018
			.text "!"			;001D
OP_hdinit               sta bank_port0                  ;001E -> 0024
			.text "IDE64"			;0021
			.text "!"			;0026
			rts				;0027
OP_init_buffer_pointers sta bank_port0                  ;0028 -> 002E
			jsr check_drive                 ;002B <- BANK0
exitbank0               sta bank_port0                  ;002E
			rts				;0031
OP_XIT_check_partition_selection sta bank_port0                  ;0032 -> 0038
			jsr find_free_sector            ;0035 <- BANK0
                        sta bank_port0                  ;0038
			rts				;003B
OP_XIT_hdinit_2         sta bank_port0                  ;003C -> 0042
			jsr OP_XIT_do_command_channel   ;003F <- BANK0
                        sta bank_port0                  ;0042
			rts				;0045
OP_XIT_init_filesystem_from_disk sta bank_port0                  ;0046 -> 004C
			jsr OP_XIT_execute_15command_open;0049 <- BANK0
                        sta bank_port0                  ;004C
			rts				;004F
search_buffer_A         sta bank_port0                  ;0050 -> 0056
			jsr update_filelen              ;0053 <- BANK0
                        sta bank_port0                  ;0056
			rts				;0059
XIT_flush_buf           sta bank_port0                  ;005A -> 0060
			jsr XIT_finalize_direntry       ;005D <- BANK0
                        sta bank_port0                  ;0060
			rts				;0063
			.text "C64"			;0064
			jsr XIT_find_free_flush         ;0067 <- BANK0
                        sta bank_port0                  ;006A
append_status_dec       sta bank_port1                  ;006D -> 0073
			jsr check_drive                 ;0070 <- BANK1
exitbank1               sta bank_port1                  ;0073
			rts				;0076
is_special_s            sta bank_port1                  ;0077 -> 007D
			jsr find_free_sectors_tree      ;007A <- BANK1
                        sta bank_port1                  ;007D
			rts				;0080
LWOP_disk_status        sta bank_port1                  ;0081 -> 0087
			jsr linearaccess                ;0084 <- BANK1
                        sta bank_port1                  ;0087
			rts				;008A
OP_get_partnum          sta bank_port1                  ;008B -> 0091
			.text "IDE64"			;008E
			.text "!"			;0093
			rts				;0094
			.text "IDE64"			;0095
			.text "C64"			;009A
			jmp manager                     ;009D <- BANK0
			.text "IDE64"			;00A0
			.text "IDE64"			;00A5
			.text "IDE64"			;00AA
			.text "IDE64"			;00AF
			.text "IDE64"			;00B4
			.text "IDE64"			;00B9
			.text "IDE64"			;00BE
			.text "IDE64"			;00C3
			jsr XIT_init_drive              ;00C8 <- BANK0
                        sta bank_port0                  ;00CB
			jsr XIT_load_tree               ;00CE <- BANK0
                        sta bank_port0                  ;00D1
			jsr XIT_prealloc_dir_sector     ;00D4 <- BANK0
                        sta bank_port0                  ;00D7
			jsr XIT_read_a_sector           ;00DA <- BANK0
                        sta bank_port0                  ;00DD
			jsr XIT_read_in_buffer          ;00E0 <- BANK0
                        sta bank_port0                  ;00E3
			jsr XIT_save_tree               ;00E6 <- BANK0
                        sta bank_port0                  ;00E9
			jsr XIT_write_a_sector          ;00EC <- BANK0
                        sta bank_port0                  ;00EF
			jsr XIT_write_out_buffer        ;00F2 <- BANK0
                        sta bank_port0                  ;00F5
			jsr XIT_init_drive              ;00F8 <- BANK1
                        sta bank_port1                  ;00FB
OP_short_path           sta bank_port1                  ;00FE -> 0104
			jsr XIT_read_a_sector2          ;0101 <- BANK0
                        sta bank_port0                  ;0104
			rts				;0107
			.text "64"			;0108
			jsr XIT_load_tree               ;010A <- BANK1
                        sta bank_port1                  ;010D
OP_XIT_partnum_delimiter sta bank_port1                  ;0110 -> 0116
			.text "IDE64"			;0113
			.text "!"			;0118
			rts				;0119
			.text "64"			;011A
			jsr XIT_read_a_sector           ;011C <- BANK1
                        sta bank_port1                  ;011F
OP_XIT_resolv_path      sta bank_port1                  ;0122 -> 0128
			.text "IDE64"			;0125
			.text "!"			;012A
			rts				;012B
			.text "IDE64"			;012C
			.text "IDE64"			;0131
			.text "IDE64"			;0136
			.text "IDE64"			;013B
OP_XIT_resolv_path_part sta bank_port1                  ;0140 -> 0146
			.text "IDE64"			;0143
			.text "!"			;0148
			rts				;0149
			.text "64"			;014A
			jsr XIT_save_tree               ;014C <- BANK1
                        sta bank_port1                  ;014F
			.text "SOCI"			;0152
			jsr XIT_upload_next_sector      ;0156 <- BANK1
                        sta bank_port1                  ;0159
			.fi

			.if BANK=3
numtoasc16              sta bank_port2                  ;0000 -> 0006
			jsr getcconv                    ;0003 <- BANK2
exitbank2               sta bank_port2                  ;0006
			rts				;0009
XIT_upload_next_sector  sta bank_port2                  ;000A -> 0010
			.text "IDE64"			;000D
			.text "!"			;0012
			rts				;0013
			.text "IDE64"			;0014
			.text "IDE64"			;0019
			.text "C64"			;001E
			jsr OP_read_to_direntry         ;0021 <- BANK1
exitbank1               sta bank_port1                  ;0024
append_status_dec       sta bank_port1                  ;0027 -> 002D
			.text "IDE64"			;002A
			.text "!"			;002F
			rts				;0030
			.text "64"			;0031
			jsr XIT_dir_first               ;0033 <- BANK1
                        sta bank_port1                  ;0036
iecin                   sta bank_port1                  ;0039 -> 003F
			.text "IDE64"			;003C
			.text "!"			;0041
			rts				;0042
			.text "64"			;0043
			jsr XIT_dirlp2                  ;0045 <- BANK1
                        sta bank_port1                  ;0048
ieclisten               sta bank_port1                  ;004B -> 0051
			.text "IDE64"			;004E
			.text "!"			;0053
			rts				;0054
			.text "64"			;0055
			jmp monitor                     ;0057 <- BANK1
iecout                  sta bank_port1                  ;005A -> 0060
			jmp pclink_load                 ;005D <- BANK1
iectalk                 sta bank_port1                  ;0060 -> 0066
			rts				;0063
LWNO_set_new314vect     sta bank_port0                  ;0064 -> 006A
			.text "64"			;0067
			rts				;0069
			.text "C64"			;006A
			rts				;006D
LWOP_init_c128key       sta bank_port0                  ;006E -> 0074
			jsr pclink_open_real            ;0071 <- BANK0
exitbank0               sta bank_port0                  ;0074
			rts				;0077
OP_findunusedchannel    sta bank_port0                  ;0078 -> 007E
			jsr XIT_dir_first               ;007B <- BANK0
                        sta bank_port0                  ;007E
			rts				;0081
hackedb2                sta bank_port0                  ;0082
			jsr XIT_dirlp2                  ;0085 <- BANK0
                        sta bank_port0                  ;0088
			jmp monitor                     ;008B <- BANK0
listbank0               sta bank_port0                  ;008E
			jmp newconsole                  ;0091 <- BANK0
mymisc                  sta bank_port0                  ;0094
			jmp pclink_save                 ;0097 <- BANK1
iectksa                 sta bank_port1                  ;009A -> 00A0
overt                   sta bank_port0                  ;009D
load_end                sta bank_port1                  ;00A0
			rts				;00A3
			.text "IDE64"			;00A4
			.text "IDE64"			;00A9
			.text "IDE64"			;00AE
			.text "IDE64"			;00B3
			.text "IDE64"			;00B8
			.text "IDE64"			;00BD
			.text "IDE64"			;00C2
iecunlisten             sta bank_port1                  ;00C7 -> 00CD
			.text "C64"			;00CA
iecuntalk               sta bank_port1                  ;00CD -> 00D3
			rts				;00D0
			.text "64"			;00D1
iecsecond               sta bank_port1                  ;00D3 -> 00D9
			rts				;00D6
			.text "64"			;00D7
LWOP_disk_status        sta bank_port1                  ;00D9 -> 00DF
			rts				;00DC
			.text "64"			;00DD
OP_atapi_packet         sta bank_port1                  ;00DF -> 00E5
			rts				;00E2
			.text "64"			;00E3
check_wildcards         sta bank_port1                  ;00E5 -> 00EB
			rts				;00E8
			.text "64"			;00E9
check_wildtype          sta bank_port1                  ;00EB -> 00F1
			rts				;00EE
			.text "IDE64"			;00EF
			rts				;00F4
OP_atapi_datain_command sta bank_port1                  ;00F5 -> 00FB
			.text "IDE64"			;00F8
			.text "!"			;00FD
			rts				;00FE
			.text "IDE64"			;00FF
			.text "C64"			;0104
OP_copy_filename_to_path sta bank_port1                  ;0107 -> 010D
			.text "IDE64"			;010A
			.text "!"			;010F
			rts				;0110
			.text "IDE64"			;0111
			.text "C64"			;0116
OP_path_searchtype      sta bank_port1                  ;0119 -> 011F
			.text "IDE64"			;011C
			.text "!"			;0121
			rts				;0122
			.text "IDE64"			;0123
OP_short_path           sta bank_port1                  ;0128 -> 012E
			.text "C64"			;012B
OP_XIT_resolv_path_part sta bank_port1                  ;012E -> 0134
			rts				;0131
			.text "64"			;0132
load_install_write_verify_byte sta bank_port1                  ;0134 -> 013A
			rts				;0137
			.text "64"			;0138
OP_load_loading         sta bank_port1                  ;013A -> 0140
			rts				;013D
			.text "IDE64"			;013E
			rts				;0143
			.text "IDE64"			;0144
OP_load_searching_for   sta bank_port1                  ;0149 -> 014F
			.text "IDE64"			;014C
			.text "!"			;0151
			rts				;0152
OP_save_saving          sta bank_port1                  ;0153 -> 0159
			.text "IDE64"			;0156
			.text "!"			;015B
			rts				;015C
			.fi

