;
; man.asm - File manager lower half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; starts in cfg_16
;

m_p1		= $fb
m_p2		= $fd
m_p3		= $14
m_p4		= $22
m_p5		= $24
m_ascii		= $57
cconv		= $1e00
man_dirmem1	= $2000
man_dirmem2	= $6000
man_winstore	= $c000

manager		.proc
		#sta_cfg_open

		lda #$37
		sta $1

		ldx #manager_colors_end_exp-manager_colors_exp-1
ld              lda manager_colors,x
                sta manager_colors_exp,x
                dex			;set default colors
                bpl ld

		jsr manager_data_swap

		ldx #47
vlp		lda $d000-1,x
		sta man_oldvic-1,x
		dex
		bne vlp
                stx man_valid
                stx man_valid+1
		lda 650
		sta man_old650

		jsr man_check_sign
                beq redraw

		lda ActualDev
                cmp #31
                bcs *+6
                cmp #8
                bcs *+4
                lda #12
		sta man_drive
		sta man_drive+1
                ldx #5
ldk             lda defaultp-1,x
                sta man_relpath-1+$000,x
                sta man_relpath-1+$100,x
                dex
                bne ldk
		stx man_bar
		stx man_bar+1
		stx man_el_l
		stx man_el_l+1
		stx man_el_h
		stx man_el_h+1
                stx man_partition
                stx man_partition+1
		stx man_selectedwin	;0

		jsr man_set_sign

redraw		#sta_cfg_16
		jsr getcconv
		#sta_cfg_open
                ldx #4
                ldy #8
                lda #8+48*4
                sec
ldf		pha
		lda manager_bar_color_exp
		sta $d027,x
                lda #35
                sta $7f8,x
                pla
                sta $d000,y
                sbc #48
                dey
                dey
                dex
                bpl ldf
		lda #128
		sta 650
		asl
		sta $d010
		sta 198
		sta msgmode
		sta $d017
		sta $d01c
		jsr bary
		ldx #63
l		sta $08c0,x
		cpx #24
                bne *+4
                lda #255
		dex
		bpl l

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda manager_brcolor_exp
		sta $d020
		lda manager_bgcolor_exp
		sta $d021
		lda #200
		sta $d016
		lda #27
		sta $d011
		lda #22
		sta $d018
		lda #3
		sta $dd00
		lda #63
		sta $dd02
                lsr			;lda #%00011111
		sta $d015
		sta $d01b
		sta $d01d
		jsr clrscr
		lda manager_misc_color_exp
		ldx #0
rp		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $db00,x
		inx
		bne rp
		
                jsr topunsel		;cfg16

		jsr winselcolupdate	;cfg16

		lda man_selectedwin
		pha
		#lda0
		sta man_selectedwin
		sta man_oldsc_h
		sta man_oldsc_h+1
		jsr redrwincap
		inc man_selectedwin
		jsr redrwincap

iy		lda StopFlag
		eor #$7f
		beq iy

		ldx #110
rpf		lda $dd00
		bmi okn
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		dex
		bne rpf
okn
		pla
		sta man_selectedwin
		jsr changepanelforce
		jsr main_reload2
		jsr scrollbar
                jsr changepanelforce
		jsr main_reload2
		jsr scrollbar

klp		jsr vbn
		#jmps klp

vbn		jsr placebar
		jsr scrollbar

kllp		lda 651
		lsr
		beq xf
		lda #2
		sta 651
xf
		lda 653
		lsr
		lsr
		bcs topmenu	;C= key
		lsr
		bcc u		;control
		jsr changepanel
		jsr changepanel2
		lda #4
u2		bit 653
		bne u2		;wait release

u		lda 198
		beq kllp
		lda 631
		dec 198
		ldx man_selectedwin

		ldy #256-3
dh		iny
		iny
		iny
		cpy #funce-func
		beq nn
		cmp func,y
		bne dh

		lda func+2,y
		pha
		lda func+1,y
		pha
nn		rts

defaultp	.text "CD:/",0

func		.byte 17		;down
		.word main_down-1
		.byte 145		;up
		.word main_up-1
		.byte "1"		;1
		.word main_reload-1
		.byte 20		;del
		.word main_select-1
		.byte 19		;home
		.word main_home-1
		.byte 137		;f2
		.word main_home-1
		.byte "."		;.
		.word main_parentdir-1
		.byte "/"		;/
		.word main_rootdir-1
		.byte "3"		;3
		.word main_view-1
		.byte 95		;<-
		.word main_exit-1
		.byte 13		;return
		.word main_return-1
		.byte 141		;sh+return
		.word main_shreturn-1
		.byte 133		;f1
		.word main_pgup-1
		.byte 157		;left
		.word main_pgup-1
		.byte 136		;f7
		.word main_pgdn-1
		.byte 29		;right
		.word main_pgdn-1
		.byte 140		;f8
		.word main_end-1
		.byte 147		;clr
		.word main_end-1
		.byte "*"		;*
		.word main_invselect-1
		.byte "+"		;+
		.word main_allselect-1
		.byte "-"		;-
		.word main_noneselect-1
		.byte "5"		;5
		.word main_copy-1
		.byte "7"		;7
		.word main_mkdir-1
                .byte "9"		;9
                .word main_command-1
funce

fullbar		.byte ":DESU"
freebar		.byte ":EERF"
txtloading	.byte 13,13,2,2,"L"+128,"O"+128,"A"+128,"D"+128,"I"+128,"N"+128,"G"+128," "+128,"D"+128,"I"+128,"R"+128,0
		.pend
;---------------------------
; Main cursor down
;
main_down	.proc
		ldy man_el_h,x
		lda man_el_l,x
		sec
		adc man_bar,x
		bcc *+3
		iny
		cmp man_files_l,x
		tya
		sbc man_files_h,x
		bcs x
		lda man_bar,x
		cmp #10
		beq o2
		inc man_bar,x
x		rts

o2		inc man_el_l,x
		bne y
		inc man_el_h,x
y		#jmps printdir
		.pend

;---------------------------
; Main cursor up
;
main_up		.proc
		lda man_bar,x
		beq o1
		dec man_bar,x
x		rts

o1		lda man_el_l,x
		bne py
		lda man_el_h,x
		beq x
		dec man_el_h,x
py		dec man_el_l,x
		#jmps printdir
		.pend

;---------------------------
; Main reload dir
;
main_reload2	.proc
		#stz_a $d015
		jsr ident_drive
                jsr same_dir
                bne main_reload
                ldx man_selectedwin+1
                lda man_valid,x
                beq main_reload
                jsr man_copypanel
                #jmps main_reload.in

main_reload	.proc
		#stz_a $d015                
		jsr mloaddir
		jsr sortdir
in		ldx man_selectedwin
		#lda0
		sta man_el_l,x
		sta man_el_h,x
		sta man_bar,x
                lda #1
                sta man_valid,x
		jsr printdlabel
		jsr man_printstat
		jsr printdir
		
spron		.proc
		lda #%00011111
		sta $d015
		rts
		.pend

;---------------------------
; Main (de)select file
;
main_select	.proc
		jsr calc_filepos_cursor
		jsr man_toggle_sel
		jsr man_printstat
		jsr printdir
		ldx man_selectedwin
		#jmps main_down
		.pend

;---------------------------
; Main invert selection
;
main_invselect	.proc
		#lda0
		.byte SKIP2
main_allselect	.proc
		lda #128
		.byte SKIP2
main_noneselect	.proc
		lda #1
		sta m_ascii+3
		#stz_a m_ascii+1
		#stz_aa m_ascii+2

lp		ldy man_selectedwin
		#ldatax m_ascii+1
		cmp man_files_l,y
		lda m_ascii+2
		sbc man_files_h,y
		bcs ss
		lda m_ascii+2
                lsr
		txa
		jsr calc_filepos
		jsr man_ext
		cmp #"D"
		bne k1
		cpx #"I"
		bne k1
		cpy #"R"
		beq k
k1		lda m_ascii+3
		beq k2
		jsr man_sel
		bpl k
k2		jsr man_toggle_sel
k		inc m_ascii+1
		bne lp
		inc m_ascii+2
		#jmps lp

ss		jsr man_printstat
		#jmps printdir
		.pend

;---------------------------
; Main go to parent dir
;
main_parentdir	.proc
		#stz_a $d015
		jsr man_cdpp
in		jsr showerror
		#jmps main_reload
		.pend

;---------------------------
; Main go to root dir
;
main_rootdir	.proc
                #stz_a $d015
		jsr man_cdroot
		#jmps main_parentdir.in
		.pend

;---------------------------
; Main viewer
;
main_view	.proc
		lda man_files_l,x
		ora man_files_h,x
		beq err

		jsr calc_filepos_cursor

		jsr man_copyfname

		ldx #10
		stx ActualFNLength
dp		lda viewf-1,x
		sta cconv-1,x
		dex
		bne dp
in
		#sta_cfg_open
		lda setup_boot_drive_exp
		#sta_cfg_16
		sta ActualDev

		lda #<cconv
		sta ActualFilename
		lda #>cconv
		sta ActualFilename+1

		#lda0
		tax
		ldy #$10
		sta ActualSecAddr
		sta $d015
		jsr newload_t

		lda $90
		eor #$40
		bne pr
		bcc ui
pr		jsr read_errchannel
		jsr showerror
		ldx man_selectedwin
		lda man_drive,x
		sta ActualDev
                jsr spron
		#jmps getcconv
err		rts

ui		pla
		pla

		ldx man_selectedwin
		lda man_drive,x
		sta ActualDev

		#psr manager.redraw
		#psr gotobank0back
		#psr exit2basic
		#psr $1003
		ldx #<$201
		ldy #>$201
		lda $200
		jmp exit2basic

viewf		.text "1//:VIEWER"
		.pend

;---------------------------
; Main exit
;
main_exit	.proc
		#stz_a $d015
		jsr savewin
		.word $571
		.byte 20,6

		jsr drawwin
                .word $571
		.byte 20,6
		.word txtexit

		lda 198
		beq *-2

		jsr restorewin

		dec 198
		lda 631
		cmp #"Y"
		beq exit
		cmp #"1"
		bne spron		;exit

exit		pla
		pla
		jsr restorescreen
                jsr manager_data_swap
		pla
		pla
		#psr $e37b
		jmp exit2basic

txtexit		.byte 13,13,2,1,"Q"+128,"U"+128,"I"+128,"T"+128," "+128,"T"+128,"H"+128,"I"+128,"S"+128," "+128,"S"+128,"O"+128,"F"+128,"T"+128,"?"+128,13,13
		.byte 2,7,"Y"+128,"/"+128,"N"+128,0
		.pend

restorescreen	.proc
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		ldx #46
vlp2		lda man_oldvic,x
		sta $d000,x
		dex
		bpl vlp2
		lda man_old650
		sta 650
		jsr clrscr
		jmp $e544
		.pend

;---------------------------
; Main return
;
main_return	.proc
		#lda0
		.byte SKIP2
main_shreturn	.proc
		lda #1
		sta ActualSecAddr
		lda man_files_l,x
		ora man_files_h,x
		bne ok
		rts
ok		jsr calc_filepos_cursor
		#stz_a $d015
		jsr man_ext
		cmp #"D"
		bne nd
		cpx #"I"
		bne nd
		cpy #"R"
		bne nd
		jsr man_cd
uf		jsr showerror
		#jmps main_reload

nd		cmp #"C"
		bne nd2
		cpx #"B"
		bne nd2
		cpy #"M"
		bne nd2
		jsr man_cd2
		#jmps uf

nd2		jsr man_plugin
		bcc nd3

		jsr man_copyfname

		ldx #12+3
		stx ActualFNLength
		ldx #12
dm		lda hack-1,x
		sta cconv-1,x
		dex
		bne dm
		geq main_view.in

hack		.text "1//","P"+128,"LUGINS/:"
hackv

nd3		lda ActualSecAddr
		bne y
		lda #1
		#sta_cfg_open
		sta load_autostart_exp	;autostart
		#sta_cfg_16
y		jsr man_copyfname
		pla
		pla
		jsr restorescreen
                jsr manager_data_swap
		lda #128
		sta msgmode
		asl
		sta $0a
		pla
		pla
		#psr $e16f
		jmp exit2basic
		.pend

;---------------------------
; Main go home
;
main_home	.proc
		#lda0
		sta man_bar,x
		sta man_el_l,x
		sta man_el_h,x
		#jmps printdir
		.pend

;---------------------------
; Main PgUp
;
main_pgup	.proc
		lda man_bar,x
		bne dpy2
		lda man_el_l,x
		sec
		sbc #11
                bcs ndn
		dec man_el_h,x
		bmi main_home
ndn		sta man_el_l,x
		#jmps printdir

dpy2		#lda0
		sta man_bar,x
		rts
		.pend

;---------------------------
; Main PgDn
;
main_pgdn	.proc
		lda #10
		cmp man_bar,x
		bne dpy2
		lda man_el_l,x
		adc #21-1
		tay
		lda man_el_h,x
		adc #0
		pha
		tya
		cmp man_files_l,x
		pla
		sbc man_files_h,x
		bcs main_end
		lda man_el_l,x
		adc #11
                bcc main_pgup.ndn
		inc man_el_h,x
                gcs main_pgup.ndn

dpy2		ldy man_files_h,x
		bne u
		cmp man_files_l,x
		bcs main_end
u		sta man_bar,x
		rts
		.pend

;---------------------------
; Main end
;
main_end	.proc
		lda #10
		ldy man_files_h,x
		bne u
		cmp man_files_l,x
		bcc u
		lda man_files_l,x
		sbc #1
		bcs vf
		#lda0
vf		sta man_bar,x
		rts

u		sta man_bar,x
		lda man_files_l,x
		sec
		sbc #11
		sta man_el_l,x
		lda man_files_h,x
		sbc #0
		sta man_el_h,x
		#jmps printdir
		.pend

;---------------------------
; Identify drive
;
ident_drive	.proc
		lda #<$430
		ldy #>$430
		ldx man_selectedwin
		beq *+6
		lda #<$610
		ldy #>$610

		sta m_p5
		sty m_p5+1

		lda #160
		ldy #8
i		sta (m_p5),y
		dey
		bpl i

		lda #1
		sta man_floppy,x

		lda #"U"
		sta man_input
		lda #"I"
		sta man_input+1
		#stz_a man_input+2

		jsr do_errchannel

		lda man_errchannel
		cmp #"7"
		bne n5

		ldx #2
		lda #","
n		inx
		beq n5
		cmp man_errchannel,x
		bne n
		lda #" "
nn		dex
		beq n5
		cmp man_errchannel,x
		bne nn
		ldy #0
n3		inx
		lda man_errchannel,x
		cmp #","
		beq n6
		and #63
		ora #128
		sta (m_p5),y
		iny
		cpy #9
		bne n3

n6		ldy #1
		lda (m_p5),y
		cmp #"5"+128
		bne n5
		dey
		lda #"1"+128
		cmp (m_p5),y
		bne n5
		ldy #3
		cmp (m_p5),y
		bne n7
		dey
		lda (m_p5),y
		cmp #"4"+128
		beq n4
		cmp #"7"+128
		beq n4
		cmp #"8"+128
		beq n4
                gne n5
n7		lda (m_p5),y
		cmp #"0"+128
		bne n5
		dey
		lda (m_p5),y
                cmp #"7"+128
                beq n4
n5		ldx man_selectedwin	;no 1541/1571/1581/1570
		dec man_floppy,x
n4		rts
;---------------------------
; Do chdir
;
man_cd2		.proc
		lda #"/"
		ldx #"0"
		gne man_cd.in

man_cd		.proc
		lda #"C"
		ldx #"D"
in		ldy #0
		sta (m_p1),y
		iny
		txa
		sta (m_p1),y
		iny
		lda #":"
		sta (m_p1),y
                iny
                lda #"."
                cmp (m_p1),y
                bne mvm
                iny
                cmp (m_p1),y
                bne mvm
                iny
                lda (m_p1),y
                beq man_cdpp
mvm
		jsr man_setupfname

		inc ActualFNLength
		inc ActualFNLength
		inc ActualFNLength

		lda m_p1
                pha
		clc
                adc #3
                sta ActualFilename
                lda m_p1+1
                pha
                adc #0
                sta ActualFilename+1

                jsr rel_path_m_p1
                
                ldx #0
dmf             lda (ActualFilename,x)
                beq mfd
                sta (m_p1),y
                inc ActualFilename
                bne *+4
                inc ActualFilename+1
                iny
                bne dmf
mfd		lda #"/"
		sta (m_p1),y
                iny
                txa
                sta (m_p1),y

		pla
		sta ActualFilename+1
                pla
                sta ActualFilename
		#jmps read_errchannel.inn
		.pend
;---------------------------
; Go to root
;
man_cdroot	.proc
		jsr rel_path_m_p1
		ldy #3
		lda #"/"
		ldx #1
		gne man_cdpp.in

;---------------------------
; Go to parent
;
man_cdpp	.proc
		jsr rel_path_m_p1
                dey
                lda #"/"
jcn             dey
		beq ncs
                cmp (m_p1),y
                bne jcn
                .byte SKIP2
ncs		ldy #3

		ldx #3
		lda #95
		sta man_input+2
		lda #"D"
		sta man_input+1
		lda #"C"
in		sta man_input
		lda #"/"
		sta (m_p1),y
                iny
		#lda0
		sta man_input,x
                sta (m_p1),y

;---------------------------
; Execute command, and print result
;
do_errchannel	.proc
		lda #<man_input
		sta ActualFilename
		lda #>man_input
		sta ActualFilename+1

		ldx #0
iy		lda man_input,x
		beq ie
		inx
		bne iy

ie
		.byte SKIP2
;---------------------------
; Check error channel
;
read_errchannel	.proc
		ldx #0
		stx ActualFNLength

inn		lda #15
		sta ActualSecAddr
		sta ActualLogical

		jsr newopen_t
		lda $90
		beq okp
ee		ldy #18
dg		lda notp,y
		sta man_errchannel,y
		dey
		bpl dg
		gmi uy

okp		ldx #15
		jsr newchkout_t
		bcs ee
		ldx #15
		jsr newchkin_t
		bcs ee
		ldx #0
di		jsr newgetin_t
		sta man_errchannel,x
		inx
		bmi uy
		lda Status
		beq di
		cmp #$40
		bne ee
uy
		jsr newclrchn_t
		lda #15
		jmp newclose_t

notp		.text "DEVICE NOT PRESENT",13
		.pend

;---------------------------
; Show error channel C=0 on error
;
showerror	.proc
		lda man_errchannel
		cmp #"0"
		beq v
		cmp #"1"
		beq v

		jsr savewin
		.word $593
		.byte 33,5

		jsr drawwin
                .word $593
		.byte 33,5
		.word txtdev

		ldy #0
u		lda man_errchannel,y
		cmp #13
		beq u2
		ora #128
		sta $60c,y
		iny
		cpy #32
		bne u

u3		lda man_errchannel,y
		cmp #13
		beq u2
		ora #128
		sta $614,y
		iny
		cpy #64
		bne u3

u2
		lda 198
		beq *-2
		dec 198

		jsr restorewin
                clc

v		rts

txtdev		.byte 13,2,9,"D"+128,"E"+128,"V"+128,"I"+128,"C"+128,"E"+128," "+128,"E"+128,"R"+128,"R"+128,"O"+128,"R"+128,13,1,0
		.pend

;---------------------------
; Change panel
;
changepanelforce .proc
		sec
		.byte SKIP1
changepanel	.proc
		clc
		#ldatax man_selectedwin
                sta man_selectedwin+1
		eor #1
		sta man_selectedwin
		tay
		lda man_drive,y
		sta ActualDev
                lda man_floppy,y
                bne masdrive
                bcs force
                lda ActualDev
                eor man_drive,x
		bne masdrive

                lda man_partition,y
                eor man_partition,x
                beq np		;same partition
force		php
                lda man_partition,y
                sta man_input+2
                lda #"C"
                sta man_input
                lda #"P"+128
                sta man_input+1
                ldx #<man_input
                ldy #>man_input
                lda #3
                jsr $ffbd
		jsr read_errchannel.inn
                jsr showerror
                plp
                bcc masdrive

np		jsr same_dir
		beq masdrive

		jsr rel_path_filename
                ldy #0
vm              lda (ActualFilename),y
                beq kf
                iny
                bne vm
kf		sty ActualFNLength

                jsr read_errchannel.inn
                jsr showerror
masdrive	rts

changepanel2    .proc
		lda $d011
		bpl *-3
		jsr winselcolupdate
;---------------------------
; Move fileselection
;
placebar	.proc
		ldx man_selectedwin
		lda man_bar,x
		cpx #0
		beq i
		adc #12-1
i
		asl
		asl
		asl
		adc #66

;---------------------------
; Set file selector sprite position
;
bary		.proc
		sta $d001
		sta $d003
		sta $d005
		sta $d007
		sta $d009
		rts
		.pend

;---------------------------
; Set color of panels
;
winselcolupdate	.proc
		#sta_cfg_open
		lda #<$d828
		sta m_p1
		lda #>$d828
		sta m_p1+1
		lda manager_inactwincolor_exp
		ldx man_selectedwin
		bne r1
		lda manager_actwincolor_exp
r1
		jsr draw
		#sta_cfg_open
		lda #<$da08
		sta m_p1
		lda #>$da08
		sta m_p1+1
		lda manager_inactwincolor_exp
		ldx man_selectedwin
		cpx #1
		bne draw
		lda manager_actwincolor_exp

draw		ldy #39
lp		sta (m_p1),y
		dey
		bpl lp

		ldy #68
		ldx #11
lp2		sta (m_p1),y
		pha
		tya
		clc
		adc #40
		tay
		pla
		bcc *+4
		inc m_p1+1
		dex
		bne lp2
		#sta_cfg_16
		rts
		.pend

;---------------------------
; Draw panel
;
redrwincap	.proc
		ldx #<$0428
		ldy #>$0428
		lda man_selectedwin
		beq r1
		ldx #<$0608
		ldy #>$0608
r1		stx m_p4
		sty m_p4+1

		ldy #68
		ldx #10
		lda #30+128
		.byte SKIP2
lp2		lda #93+128
		sta (m_p4),y
		tya
		clc
		adc #40
		tay
		bcc *+4
		inc m_p4+1
		dex
		bne lp2
		lda #113+128
		sta (m_p4),y
                dec m_p4+1
                
                lda #<winbar
                sta m_p3
                lda #>winbar
                sta m_p3+1
		#jmps drawtext

winbar		.byte " "+128,"D"+128,"E"+128,"V"+128,"I"+128,"C"+128,"E"+128,":"+128
		.byte " "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte "N"+128,"A"+128,"M"+128,"E"+128,":"+128
		.byte " "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte " "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
                .byte 13,13,2,28,"BLOCKS:"
		.byte 13,13,2,28,"FILES:"
                .byte 13,13,2,28,"USED:"
		.byte 13,13,2,28,"PARTITION:",0
		.pend

;---------------------------
; clear screen
;
clrscr		.proc
		ldx #24
		lda #32
		sta $400-24,x
		inx
		bne *-4
		sta $500-24,x
		inx
		bne *-4
		sta $600-24,x
		inx
		bne *-4
		sta $700-24,x
		inx
		bne *-4
		rts
		.pend

;---------------------------
; Print disklabel
;
printdlabel	.proc
		lda #<(man_dirmem1-26)
		sta m_p1
		lda #>(man_dirmem1-26)
		sta m_p1+1

		ldx #<$43f
		ldy #>$43f
		lda man_selectedwin
		beq r1
		ldx #<$61f
		ldy #>$61f
		lda #>(man_dirmem2-26)
		sta m_p1+1
r1		stx m_p2
		sty m_p2+1

		ldy #15
xu		lda (m_p1),y
		tax
		lda cconv,x
		eor #128
		sta (m_p2),y
		dey
		bpl xu
		rts
		.pend

;---------------------------
; Print decimal number
;
numtoasc16	.proc
		stx m_ascii+4
		sta m_ascii+5
		#stz_a m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #16
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		ldx #2
p		lda m_ascii+1,x
		adc m_ascii+1,x
		sta m_ascii+1,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #133
		gne numtoasc24.in

numtoasc24	.proc
		stx m_ascii+4
		sta m_ascii+5
		sty m_ascii+6
		#stz_a m_ascii
		#stz_aa m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #24
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		rol m_ascii+6
		ldx #3
p		lda m_ascii,x
		adc m_ascii,x
		sta m_ascii,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #135

		lda m_ascii
		jsr h
in		lda m_ascii+1
		jsr h
		lda m_ascii+2
		jsr h
		lda m_ascii+3

h		pha
		lsr
		lsr
		lsr
		lsr
		jsr aa
		pla
aa		and #15
		bne r2
		dex
		bmi r
r2		ora #$30
		tax
		sta (m_p2),y
		iny
r		rts
		.pend
;---------------------------
; Print panel statistics
;
man_printstat	.proc
		ldx #<$4bf
		lda #>$4bf
		ldy man_selectedwin
		beq *+6
		ldx #<$69f
		lda #>$69f

		stx m_p2
		sta m_p2+1

		ldx man_block_l,y
		lda man_block_m,y
		pha
		lda man_block_h,y
		tay
		pla
		jsr num

		ldy man_selectedwin
		lda man_fullfree,y
		cmp #"F"
		beq *+3
		clc

		ldy #39
		ldx #4
ig		lda manager.fullbar,x
		bcc if
		lda manager.freebar,x
if
		sta (m_p2),y
		iny
		dex
		bne ig

		ldy man_selectedwin
		ldx man_filessel_l,y
		lda man_filessel_h,y
		jsr num2

		ldy man_selectedwin
		ldx man_fulllo,y
		lda man_fullhi,y
		jsr num2
		ldy man_selectedwin
		ldx man_partition,y
		#lda0
num2		ldy #0
num		jsr numtoasc24
		lda #32
iy		cpy #8
		bcs iy2
		sta (m_p2),y
		iny
		bne iy
iy2
		lda m_p2
		clc
		adc #80
		sta m_p2
		bcc *+4
		inc m_p2+1
		rts
		.pend

;---------------------------
; Get parameter
;
getparm		.proc
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p1),y
		rts
		.pend

;---------------------------
; Draw 1 line of window
;
windrln		.proc
		sty m_ascii+3
		ldy m_ascii
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
dy		lda m_ascii+2
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
		bne dy
		lda m_ascii+3
		sta (m_p1),y
		txa
		sta (m_p2),y
		rts
		.pend

;---------------------------
; Draw a window
;
; .word screen_position		($00xx mean it's in X/Y)
; .byte width-1, height-1
; .word text_in_memory
;
drawwin		.proc
		lda $d011
		bpl *-3
		pla
		sta m_p1
		pla
		sta m_p1+1
                sty m_p4+1

		ldy #0
                jsr getparm
                sta m_p4
                jsr getparm
                bne vd2
                stx m_p4
                .byte SKIP2
vd2             sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
		jsr getparm
		sta m_p3
		jsr getparm
		sta m_p3+1

		lda m_p1+1
		pha
		lda m_p1
		pha

		lda m_p4
		sta m_p1
		sta m_p2
		lda m_p4+1
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		#sta_cfg_open
		#ldatax manager_win_color_exp
		#sta_cfg_16

		lda #64+128
		sta m_ascii+2
		ldy #112+128
		lda #110+128
		jsr windrln

lp		lda m_p1
		clc
		adc #40
		sta m_p1
		sta m_p2
		bcc ni
		inc m_p1+1
		inc m_p2+1
ni
		dec m_ascii+1
		beq ki

		lda #32+128
		sta m_ascii+2
		lda #93+128
                tay
		jsr windrln
		#jmps lp
ki
		lda #64+128
		sta m_ascii+2
		ldy #109+128
		lda #125+128
		jsr windrln

drawtext	.proc
fr2		ldy #0
fr		lda (m_p3),y
		bmi ok
		beq vege
		cmp #13
		bne o1
rp		tya
		adc m_p3
		sta m_p3
		bcc *+4
		inc m_p3+1
		lda m_p4
		clc
		adc #40
		sta m_p4
		bcc fr2
		inc m_p4+1
		gcs fr2

o1		cmp #29
		beq oo
                cmp #2
                bne vd
                iny
                lda (m_p3),y
                sta m_p1
                lda m_p3
                sbc m_p1
                sta m_p3
                bcs *+4
                dec m_p3+1
                tya
                sec
                adc m_p1
                tay
                bne fr

vd		cmp #1
		bne ok
		tya
		clc
		adc m_p4
		sta m_p1
		sta m_p2
		lda m_p4+1
		adc #0
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		#phy_a
		lda #64+128
		sta m_ascii+2
		ldy #107+128
		lda #115+128
		jsr windrln
		#ply_a
		sec
		gcs rp

ok		sta (m_p4),y
oo		iny
		bne fr
vege		rts
		.pend

;---------------------------
; Restore a window
;
; .word screen_position
; .byte width-1, height-1
;
restorewin	.proc
		lda $d011
		bpl *-3
		lda #<(man_savedwin-1)
                sta m_p1
                lda #>(man_savedwin-1)
                sta m_p1+1
                jsr savewin.win
		lda #1
		gne savewin.in
;---------------------------
; Save a window
;
; .word screen_position
; .byte width-1, height-1
;
savewin		.proc
		pla
		sta m_p1
		pla
		sta m_p1+1

		jsr win

		lda m_p1+1
		pha
		lda m_p1
		pha

		#lda0
in		sta m_ascii+2
		lda #<man_winstore
		sta m_p1
		lda #>man_winstore
		sta m_p1+1

lp		ldx m_ascii
		ldy m_ascii+2
		beq fy
		dey
fy2		lda (m_p1),y
		sta (m_p3),y
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p1),y
		sta (m_p4),y
		iny
		dex
		bpl fy2
		gmi rf

fy		lda (m_p3),y
		sta (m_p1),y
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p4),y
		sta (m_p1),y
		iny
		dex
		bpl fy

rf		tya
		clc
		adc m_p1
		sta m_p1
		bcc *+4
		inc m_p1+1

		lda m_p3
		clc
		adc #40
		sta m_p3
		sta m_p4
		bcc *+6
		inc m_p3+1
		inc m_p4+1

		dec m_ascii+1
		bpl lp
		rts

win		ldy #4
fwf		lda (m_p1),y
                sta man_savedwin-1,y
                dey
                bne fwf
		jsr getparm
		sta m_p3
		sta m_p4
		jsr getparm
		sta m_p3+1
		eor #$d8^$04
		sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
                rts
		.pend

;---------------------------
; Handle top menu
;
topmenu		.proc
		#stz_a $d015

		lda man_selectedwin
		pha
                sec
		ror man_selectedwin
		jsr winselcolupdate
		pla
		sta man_selectedwin
		#sta_cfg_open

		ldx #39
lp		lda manager_actwincolor_exp
		sta $d800,x
		lda menubar,x
		sta $400,x
		dex
		bpl lp
		#sta_cfg_16

		lda man_selectedwin
		beq leftp

rightp		jsr savewin
		.word $447
		.byte 7,10

		jsr drawwin
                .word $447
		.byte 7,10
		.word txtdrives

		lda man_drive+1
		ldx #<$d8c0
		ldy #>$d8c0
		jsr drselm

		pha
		jsr restorewin
		pla
		cmp #29
		beq leftp
		cmp #157
		beq optionsp
		ldx #1
		stx man_selectedwin
		gne ss

key		.byte "8","9","0","1","2","3","4",155,41,129,149,150,151
dr		.byte 8,9,10,11,12,13,14,8,9,11,12,13,14

leftp		jsr savewin
		.word $429
		.byte 7,10

		jsr drawwin
                .word $429
		.byte 7,10
		.word txtdrives

		lda man_drive
		ldx #<$d8a2
		ldy #>$d8a2
		jsr drselm

		pha
		jsr restorewin
		pla
		cmp #157
		beq rightp
		cmp #29
		beq optionsp
		ldx #0
		stx man_selectedwin
		geq ss

drselm		pha
		lda #6
		sta m_ascii+2
		lda #5
		sta m_ascii
		pla
		sec
		sbc #8
		bcc e2
		cmp #7
		bcs e2
		.byte SKIP2
e2		lda #0
		sta m_ascii+5
		stx m_p1
		sty m_p1+1

		#sta_cfg_open
		lda manager_selbar_color_exp
		jsr man_paintselbar

		jsr move_sel_bar
		#sta_cfg_16
		rts

optionsp	jsr savewin
		.word $433
		.byte 16,2

		jsr drawwin
                .word $433
		.byte 16,2
		.word txtoptions

		ldx #<$d85c
		ldy #>$d85c
		lda #14
		sta m_ascii
		#stz_a m_ascii+2
		jsr e2

		pha
		jsr restorewin
		pla
		cmp #157
		beq leftp
		cmp #29
		beq rightp
		cmp #13
		beq about
		gne ex

ss		ldy #dr-key
lpp		cmp key-1,y
		bne oo
		lda dr-1,y
		gne n
oo		dey
		bne lpp

		cmp #13
		bne ex

		lda m_ascii+5
		adc #8-1
n		sta man_drive,x
		sta ActualDev
		jsr winselcolupdate
		jsr topunsel
                jsr man_cdroot
		jsr main_reload2
		#jmps u

ex		jsr winselcolupdate
		jsr topunsel

		jsr spron
u		lda 653
		and #2
		bne u
		rts			;exit

about		jsr savewin
		.word $59a
		.byte 19,6

		jsr drawwin
                .word $59a
		.byte 19,6
		.word txtabout

		lda 198
		beq *-2
		dec 198

		jsr restorewin
		#jmps ex

txtdrives	.byte 13,29,"D"+128,"R"+128,"I"+128,"V"+128,"E"+128,":"+128,13,1
		.byte 29,29,"8"+128,13
		.byte 29,29,"9"+128,13
		.byte 29,29,"1"+128,"0"+128,13
		.byte 29,29,"1"+128,"1"+128,13
		.byte 29,29,"1"+128,"2"+128,13
		.byte 29,29,"1"+128,"3"+128,13
		.byte 29,29,"1"+128,"4"+128,0

txtoptions	.byte 13,29,29,"A"+128,"B"+64,"O"+64,"U"+64,"T"+64," "+128,"M"+128,"A"+128,"N"+128,"A"+128,"G"+128,"E"+128,"R"+128,0

txtabout	.byte 13,29,29,"I"+128,"D"+128,"E"+128," "+128,"F"+128,"I"+128,"L"+128,"E"+128," "+128,"M"+128,"A"+128,"N"+128,"A"+128,"G"+128,"E"+128,"R"+128,13,1
		.byte 29,29,"V"+128,"E"+64,"R"+64,"S"+64,"I"+64,"O"+64,"N"+64,":"+128," "+128,"0"+128,"."+128,"0"+128,"0"+128,13
		.byte 29,29,"D"+128,"A"+64,"T"+64,"E"+64,":"+128," "+128,"2"+128,"0"+128,"0"+128,"4"+128,"/"+128,"0"+128,"5"+128,"/"+128,"2"+128,"8"+128,13
		.byte 29,29,"H"+64,"T"+64,"T"+64,"P"+64,":"+128,"/"+128,"/"+128,"I"+64,"D"+64,"E"+64,"6"+128,"4"+128,"."+128,"O"+64,"R"+64,"G"+64,0

menubar		.byte " "+128," "+128," "+128," "+128,"U"+128,"P"+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte " "+128,"M"+128,"I"+128,"S"+128,"C"+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128," "+128
		.byte "D"+128,"O"+128,"W"+128,"N"+128," "+128," "+128," "+128
		.pend

topunsel	.proc
		#sta_cfg_open
		ldx #39
lp3		lda manager_inactwincolor_exp
		sta $d800,x
		lda topbar,x
		sta $400,x
		dex
		bpl lp3
		#sta_cfg_16
		rts

topbar		.byte "1"+128,"-"+128,"D"+128,"I"+128,"R"+128," "+128
		.byte "3"+128,"-"+128,"V"+128,"I"+128,"E"+128,"W"+128," "+128
		.byte "5"+128,"-"+128,"C"+128,"O"+128,"P"+128,"Y"+128," "+128
		.byte "6"+128,"-"+128,"R"+128,"E"+128,"N"+128,"A"+128," "+128
		.byte "7"+128,"-"+128,"M"+128,"K"+128,"D"+128,"I"+128,"R"+128," "+128
		.byte "8"+128,"-"+128,"D"+128,"E"+128,"L"+128
		.pend
;---------------------------
; Color selection bar
;
man_paintselbar	.proc
		pha
		lda m_p1
		sta m_p2
		lda m_p1+1
		sta m_p2+1
		ldy m_ascii+5
c2		clc
c		dey
		bmi i
		lda m_p2
		adc #40
		sta m_p2
		bcc c
		inc m_p2+1
		gcs c2

i		pla
		ldy m_ascii
ll		sta (m_p2),y
		dey
		bpl ll
		rts
		.pend

;---------------------------
; Move menu selector
;
move_sel_bar	.proc
lp		lda 198
		beq *-2
		lda 631
		dec 198

		cmp #17
		bne n1
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+5
		cpx m_ascii+2
		inx
		bcc *+4
		ldx #0
		stx m_ascii+5
l		lda manager_selbar_color_exp
		jsr man_paintselbar
		#jmps lp

n1		cmp #145
		bne n2
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+5
		dex
		bpl *+4
		ldx m_ascii+2
ll		stx m_ascii+5
		#jmps l

n2		cmp #137
		beq *+10
		cmp #133
		beq *+6
		cmp #19
		bne n3
		lda m_ascii+5
		beq lp
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx #0
		geq ll
n3
		cmp #140
		beq *+10
		cmp #136
		beq *+6
		cmp #147
		bne n4
		lda m_ascii+2
		cmp m_ascii+5
		beq lp
		lda manager_win_color_exp
		jsr man_paintselbar
		ldx m_ascii+2
		#jmps ll

n4
		rts
		.pend

scrollbar	.proc
		lda #<$494
		ldy #>$494
		ldx man_selectedwin
		beq *+6
		lda #<$674
		ldy #>$674
		sta m_p2
		sty m_p2+1

		lda man_files_l,x
		sec
		sbc #1
		sta m_p3
		lda man_files_h,x
		sbc #0
		sta m_p3+1
		ora m_p3
		bcc e
		beq e
		lda man_el_l,x
		clc
		adc man_bar,x
		sta m_p1
		lda man_el_h,x
		adc #0
		asl m_p1
		rol
		asl m_p1
		rol
		asl m_p1
		rol
		sta m_p1+1

cg2		sec
cg		lda m_p1
		sbc m_p3
		sta m_p1
		lda m_p1+1
		sbc m_p3+1
		sta m_p1+1
		bcc e

		lda m_p2
		adc #40-1
		sta m_p2
		bcc cg2
		inc m_p2+1
		gcs cg

e		lda man_oldsc_l,x
		ldy man_oldsc_h,x
		beq nn
		cmp m_p2
		bne n
		cpy m_p2+1
		beq ni
n		sta m_p3
		sty m_p3+1
		ldy #0
		lda #221
		sta (m_p3),y
nn		lda #64			;186
		sta (m_p2),y
		lda m_p2
		sta man_oldsc_l,x
		lda m_p2+1
		sta man_oldsc_h,x
ni		rts
		.pend

;---------------------------
; main copy
;
main_copy	.proc
		#stz_a $d015

		lda man_filessel_l,x
		ora man_filessel_h,x
		beq tty
		gne err

tty		lda man_files_l,x
		ora man_files_h,x
		beq err
		jsr calc_filepos_cursor
		jsr man_copyfname

		ldx #5
ld		lda $201,x
		cmp illtype,x
		bne yh
		dex
		bpl ld
		gmi err

yh		ldx #0
nd		lda $201,x
		cpx ActualFNLength
		bcc vf
		#lda0
vf		sta man_input,x
		inx
		cpx #20
		bne nd

		jsr savewin
		.word $571
		.byte 21,6

		jsr drawwin
                .word $571
		.byte 21,6
		.word txtcopy

		ldy #19
ndu		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta $5c2,y
                #sta_cfg_open
                lda manager_input_color_exp
                #sta_cfg_16
                sta $d9c2,y
		dey
		bpl ndu

		ldx #<$63a
		ldy #>$63a
		lda #20
		jsr input

		jsr restorewin

err		#jmps spron		;exit

illtype		.text "..,DIR"

txtcopy		.byte 2,6,243,"C"+128,"O"+64,"P"+64,"Y"+64,235,13
		.byte 29,"F"+128,"R"+64,"O"+64,"M"+64,":"+128,13,13,13
		.byte 29,"T"+128,"O"+64,":"+128,0
		.pend
;---------------------------
; main mkdir
;
main_mkdir	.proc
		#stz_a $d015

		jsr savewin
		.word $59b
		.byte 17,4

		jsr drawwin
                .word $59b
		.byte 17,4
		.word txtmkdir

		ldx #<$5ec
		ldy #>$5ec
		lda #16
		jsr clrinput
		cmp #3			;stop?
		php
		beq xji

		ldx #16
ul		lda man_input,x
		sta man_input+3,x
		lda mdtxt,x
		sta man_input,x
		dex
		bpl ul

		jsr do_errchannel

		clc
xji		php

		jsr restorewin

                plp
                bcs *+5
                jsr showerror

		jsr spron
		plp
		bne modifieddir
jooo		rts

mdtxt		.text "MD:"
txtmkdir	.byte 29,243,"M"+128,"A"+64,"K"+64,"E"+64,160,"D"+64,"I"+64,"R"+64,"E"+64,"C"+64,"T"+64,"O"+64,"R"+64,"Y"+64,235,0
		.pend
;---------------------------
; reload other panel too if change happend in same dir
;
modifieddir     .proc
		jsr main_reload
                jsr same_dir
                bne main_mkdir.jooo
                jsr changepanel
                jsr main_reload2
                jmp changepanel
		.pend
;---------------------------
; main command
;
main_command	.proc
		#stz_a $d015

		jsr savewin
		.word $595
		.byte 29,4

		jsr drawwin
                .word $595
		.byte 29,4
		.word txtcmd

		ldx #<$5e6
		ldy #>$5e6
		lda #28
		jsr clrinput
		cmp #3			;stop?
		php
		beq xji

		jsr do_errchannel

		clc
xji		php

		jsr restorewin

                plp
                bcs *+5
                jsr showerror

		jsr spron
		plp
		bne modifieddir
		rts

txtcmd		.byte 2,6,243,"D"+128,"I"+64,"S"+64,"K"+64,160,"C"+64,"O"+64,"M"+64,"M"+64,"A"+64,"N"+64,"D"+64,235,0
		.pend
;---------------------------
; Screen input
;
clrinput	.proc
		stx m_p1
                pha
                tax
                #lda0
ld              sta man_input,x
                dex
                bpl ld
                pla
                ldx m_p1

input		.proc
maxlen		= m_p2
cpos		= m_p2+1
first		= m_p3

		stx m_p1
                stx m_p4
		sty m_p1+1
		sta maxlen
                tya
                eor #$d8^$04
                sta m_p4+1
		#stz_a cpos
		lda #192
		sta first

lp		asl first
		ldy #0
r		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta (m_p1),y
                #sta_cfg_open
                lda manager_input_color_exp
                #sta_cfg_16
                sta (m_p4),y
		iny
		cpy maxlen
		bne r

		ldy cpos
		ldx #0

lp1		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		dex
		bpl l
		ldx #16
		lda (m_p1),y
		eor #128
		sta (m_p1),y
l		lda 198
		beq lp1
		lda 631
		dec 198

;       	cmp #","
;       	beq lp
;       	cmp #":"
;       	beq lp
		cmp #"="
		beq lp

		cmp #20			;del
		bne n1
		cpy #0
		beq lp
		iny
		cpy maxlen
		bne y
		lda man_input-1,y
		beq y
ld		#lda0
		sta man_input-1,y
		geq lp
y		dey
lp2		lda man_input,y
		sta man_input-1,y
		iny
		cpy maxlen
		bcc lp2
		dec cpos
		gcs ld

n1
		cmp #157		;left
		bne n2
		cpy #0
		beq lp
		dec cpos
		#jmps lp
n2
		cmp #29			;right
		bne n3
		iny
		cpy maxlen
		beq lp
		lda man_input-1,y
		beq lp
		cpy maxlen
		beq lp
		sty cpos
		gne lp

n3
		cmp #19
		bne n4
		#stz_a cpos
		geq lp
n4
		cmp #147
		bne n5
		#lda0
		ldy maxlen
lh		sta man_input,y
		dey
		bpl lh
		sta cpos
		gmi lp
n5
		cmp #148
		bne n6
		ldy maxlen
		lda man_input-1,y
		bne lp
t		dey
		cpy cpos
		beq py
		lda man_input-1,y
		sta man_input,y
		#jmps t
py		lda #32
		sta man_input,y
		gne lp

n6
		cmp #3
		beq exit
		cmp #13
		beq exit

		ldx first
		beq ig
		pha
		ldx maxlen
		#lda0
li		sta man_input,x
		dex
		bpl li
		pla

ig		sta man_input,y
		ldx cpos
		inx
		cpx maxlen
		bcs lp
		stx cpos
		gcc lp
exit		rts
		.pend
;---------------------------
; Path of current window into ActualFilename
;
rel_path_filename .proc
                lda man_selectedwin
                clc
                adc #>man_relpath
                sta ActualFilename+1
                lda #<man_relpath
                sta ActualFilename
                rts
                .pend
;---------------------------
; Path of current window into m_p1, Y at end of name
;
rel_path_m_p1  	.proc
                lda man_selectedwin
                clc
                adc #>man_relpath
                sta m_p1+1
                lda #<man_relpath
                sta m_p1
                ldy #0
nvfs            lda (m_p1),y
                beq kmv
                iny
                bne nvfs
kmv		rts
		.pend
;---------------------------
; Manager data swap
;
manager_data_swap .proc
		#sta_cfg_open
		lda #<man_data
                sta m_p3
		lda #>man_data
                sta m_p3+1
		lda #<manager_data_exp
                sta m_p1
		lda #>manager_data_exp
                sta m_p1+1
                .if SUPERCPU=1
                ldy #1
                sty m_p1+2
                dey
lp		lda (m_p3),y
		tax
                .else
                ldy #0
lp              lax (m_p3),y
                .fi
                #lda_zp_y m_p1
                sta (m_p3),y
                txa
                #sta_zp_y m_p1
                dey
                bne lp
                inc m_p1+1
                inc m_p3+1
                lda m_p3+1
                cmp #>(man_data+$300)
                bne lp
                #sta_cfg_16
                rts
		.pend

;---------------------------
; Check/set manager sign
;
man_set_sign	.proc
		clc
		.byte SKIP1
man_check_sign	.proc
		sec
		ldx #36
ldl             #sta_cfg_open
                lda ident_label_exp-1,x
                #sta_cfg_16
                bcc vdv
                cmp man_ident_label-1,x
                bne vs
vdv             sta man_ident_label-1,x
                dex
                bne ldl
vs              rts
                .pend
;---------------------------
; Same directory?
;
same_dir	.proc
                lda man_drive
                eor man_drive+1
                bne no
                lda man_partition
                eor man_partition+1
                bne no
                ldx #0
nvs             lda man_relpath,x
                cmp man_relpath+$100,x
                bne no
                tay
                beq no
                inx
                bne nvs
no		rts
		.pend
;
manager_colors	.byte 6			;manager_bgcolor_exp
		.byte 6			;manager_brcolor_exp
                .byte 12		;manager_inactwincolor_exp
		.byte 7			;manager_actwincolor_exp
		.byte 15		;manager_dircolor_exp
		.byte 14		;manager_filecolor_exp
		.byte 7			;manager_seldircolor_exp
		.byte 7			;manager_selfilecolor_exp
		.byte 0			;manager_bar_color_exp
		.byte 12		;manager_misc_color_exp
		.byte 7			;manager_win_color_exp
		.byte 1			;manager_selbar_color_exp
                .byte 3			;manager_input_color_exp
;---------------------------
; Manager data
;
		.logical $0900
man_data	= *
man_selectedwin	*=*+2			;which panel is active? (0/1)
man_drive	*=*+2			;drive number
man_valid	*=*+2			;panel valid
man_files_l	*=*+2			;number of files
man_files_h	*=*+2			;number of files
man_bar		*=*+2			;bar position
man_el_l	*=*+2			;scroll position
man_el_h	*=*+2			;scroll position
man_fulllo	*=*+2			;blocks used
man_fullhi	*=*+2			;blocks used
man_fullfree	*=*+2			;full/free
man_partition	*=*+2			;partition
man_block_l	*=*+2			;blocks selected
man_block_m	*=*+2			;blocks selected
man_block_h	*=*+2			;blocks selected
man_ident_label *=*+36			;identification
man_filessel_l	*=*+2			;files selected
man_filessel_h	*=*+2                   ;files selected
man_floppy	*=*+2                   ;drive is floppy
man_oldsc_l	*=*+2			;old scrollbar
man_oldsc_h	*=*+2                   ;old scrollbar
man_oldvic	*=*+47			;vic state
man_old650	*=*+1			;keyboard repeat state
man_savedwin	*=*+4			;to remember saved window
man_input				;input space
man_errchannel	*=*+128			;error message
man_pontpont	*=*+32			;for ".."
man_relpath	*=*+512			;paths

		.if *>$1000
		.error "man data overflow!"
		.fi
		.here

		.logical $1000
man_sort1_l	*=*+512
man_sort1_h	*=*+512
man_sort2_l	*=*+512
man_sort2_h	*=*+512
man_l_l		*=*+64
man_l_h		*=*+64
man_r_l		*=*+64
man_r_h		*=*+64
man_i_l		*=*+64
man_i_h		*=*+64
man_j_l		*=*+64
man_j_h		*=*+64
		.if *>$1e00
		.error "man data overflow!"
		.fi
		.here
